org.codehaus.plexus.component.repository

## Interface ComponentRepository

All Known Implementing Classes:
  DefaultComponentRepository

    public interface ComponentRepository

### Method Summary

Methods
`void` `addComponentDescriptor(ComponentDescriptor<?> componentDescriptor)`
`<T> ComponentDescriptor<T>` `getComponentDescriptor(java.lang.Class<T> type, java.lang.String role, java.lang.String roleHint)`
`ComponentDescriptor<?>` `getComponentDescriptor(java.lang.String role, java.lang.String roleHint, org.codehaus.plexus.classworlds.realm.ClassRealm realm)` Deprecated.
`<T> java.util.List<ComponentDescriptor<T>>` `getComponentDescriptorList(java.lang.Class<T> type, java.lang.String role)`
`<T> java.util.Map<java.lang.String,ComponentDescriptor<T>>` `getComponentDescriptorMap(java.lang.Class<T> type, java.lang.String role)`
`void` `removeComponentRealm(org.codehaus.plexus.classworlds.realm.ClassRealm classRealm)`

### Method Detail

#### addComponentDescriptor

    void addComponentDescriptor(ComponentDescriptor<?> componentDescriptor)
                                throws ComponentRepositoryException

Throws:
  `ComponentRepositoryException`

#### getComponentDescriptor

    <T> ComponentDescriptor<T> getComponentDescriptor(java.lang.Class<T> type,
                                                    java.lang.String role,
                                                    java.lang.String roleHint)

#### getComponentDescriptor

    @Deprecated
    ComponentDescriptor<?> getComponentDescriptor(java.lang.String role,
                                                           java.lang.String roleHint,
                                                           org.codehaus.plexus.classworlds.realm.ClassRealm realm)

Deprecated.

#### getComponentDescriptorMap

    <T> java.util.Map<java.lang.String,ComponentDescriptor<T>> getComponentDescriptorMap(java.lang.Class<T> type,
                                                                                       java.lang.String role)

#### getComponentDescriptorList

    <T> java.util.List<ComponentDescriptor<T>> getComponentDescriptorList(java.lang.Class<T> type,
                                                                        java.lang.String role)

#### removeComponentRealm

    void removeComponentRealm(org.codehaus.plexus.classworlds.realm.ClassRealm classRealm)